<?php

/**
 * @file
 * ExtraWatch - A real-time ajax monitor and live stats  	 	    	    		  	 	  	 	  		 	 		    	 			 	   		  	 	 		 	 	   	      	  	 		 		 				 			 		  		    	 		 		  
 * @package ExtraWatch  	 	    	    		  	 	  	 	  		 	 		    	 			 	   		  	 	 		 	 	   	      	  	 		 		 				 			 		  		    	 		 		  
 * @version 2.3  	 	    	    		  	 	  	 	  		 	 		    	 			 	   		  	 	 		 	 	   	      	  	 		 		 				 			 		  		    	 		 		  
 * @revision 2697  	 	    	    		  	 	  	 	  		 	 		    	 			 	   		  	 	 		 	 	   	      	  	 		 		 				 			 		  		    	 		 		  
 * @license http://www.gnu.org/licenses/gpl-3.0.txt     GNU General Public License v3  	 	    	    		  	 	  	 	  		 	 		    	 			 	   		  	 	 		 	 	   	      	  	 		 		 				 			 		  		    	 		 		  
 * @copyright (C) 2020 by CodeGravity.com - All rights reserved!  	 	    	    		  	 	  	 	  		 	 		    	 			 	   		  	 	 		 	 	   	      	  	 		 		 				 			 		  		    	 		 		  
 * @website http://www.extrawatch.com  	 	    	    		  	 	  	 	  		 	 		    	 			 	   		  	 	 		 	 	   	      	  	 		 		 				 			 		  		    	 		 		  
 */

defined('_JEXEC') or die('Restricted access');  	 	    	    		  	 	  	 	  		 	 		    	 			 	   		  	 	 		 	 	   	      	  	 		 		 				 			 		  		    	 		 		  

class ExtraWatchWordpressEnv implements ExtraWatchEnv  	 	    	    		  	 	  	 	  		 	 		    	 			 	   		  	 	 		 	 	   	      	  	 		 		 				 			 		  		    	 		 		  
{

   const EW_ENV_NAME = "wordpress";  	 	    	    		  	 	  	 	  		 	 		    	 			 	   		  	 	 		 	 	   	      	  	 		 		 				 			 		  		    	 		 		  

  function getDatabase($user = _EW_PROJECT_ID)  	 	    	    		  	 	  	 	  		 	 		    	 			 	   		  	 	 		 	 	   	      	  	 		 		 				 			 		  		    	 		 		  
  {
    return new ExtraWatchDBWrapWordpress();  	 	    	    		  	 	  	 	  		 	 		    	 			 	   		  	 	 		 	 	   	      	  	 		 		 				 			 		  		    	 		 		  
  }

  function getRequest()  	 	    	    		  	 	  	 	  		 	 		    	 			 	   		  	 	 		 	 	   	      	  	 		 		 				 			 		  		    	 		 		  
  {
    return new EnvRequest();  	 	    	    		  	 	  	 	  		 	 		    	 			 	   		  	 	 		 	 	   	      	  	 		 		 				 			 		  		    	 		 		  
  }

  function & getURI()  	 	    	    		  	 	  	 	  		 	 		    	 			 	   		  	 	 		 	 	   	      	  	 		 		 				 			 		  		    	 		 		  
  {
    global $post;
    return get_permalink($post->ID);  	 	    	    		  	 	  	 	  		 	 		    	 			 	   		  	 	 		 	 	   	      	  	 		 		 				 			 		  		    	 		 		  
  }

  function isSSL()
  {
      return (!empty($_SERVER['HTTPS']) && @$_SERVER['HTTPS'] != 'off');
  }

    function getRootSiteAbsolute() {
        $hostname = ExtraWatchHelper::getProtocol()."://" . $_SERVER['HTTP_HOST'];
        $scriptName = $_SERVER['SCRIPT_NAME'];
        $scriptNameExploded = explode($this->getWpContentDir()."/", $scriptName);
        if (sizeof($scriptNameExploded) > 1) {
            $subdir = @$scriptNameExploded[0];
        } else {
            $subdir = str_replace("wp-admin/admin.php", "", $scriptName);
        }
        $rootSite = $hostname . $subdir;
        return $rootSite;
    }

    function getRootSite()
  {

    $rootSite = $this->getRootSiteAbsolute();
	$url = parse_url($rootSite);  	 	    	    		  	 	  	 	  		 	 		    	 			 	   		  	 	 		 	 	   	      	  	 		 		 				 			 		  		    	 		 		  
    $liveSitePath = $url['path'];
    $liveSitePath = str_replace("index.php","",$liveSitePath);
    $liveSitePath = str_replace("/wp-admin","",$liveSitePath);
    return $liveSitePath;  	 	    	    		  	 	  	 	  		 	 		    	 			 	   		  	 	 		 	 	   	      	  	 		 		 				 			 		  		    	 		 		  
  }

  function getAdminDir()  	 	    	    		  	 	  	 	  		 	 		    	 			 	   		  	 	 		 	 	   	      	  	 		 		 				 			 		  		    	 		 		  
  {
    return "wp-admin";  	 	    	    		  	 	  	 	  		 	 		    	 			 	   		  	 	 		 	 	   	      	  	 		 		 				 			 		  		    	 		 		  
  }


  function getCurrentUser()  	 	    	    		  	 	  	 	  		 	 		    	 			 	   		  	 	 		 	 	   	      	  	 		 		 				 			 		  		    	 		 		  
  {
    return $this->getUsername();  	 	    	    		  	 	  	 	  		 	 		    	 			 	   		  	 	 		 	 	   	      	  	 		 		 				 			 		  		    	 		 		  
  }

  function getUsersCustomTimezoneOffset()  	 	    	    		  	 	  	 	  		 	 		    	 			 	   		  	 	 		 	 	   	      	  	 		 		 				 			 		  		    	 		 		  
  {
    return 0;
  }

  function getEnvironmentSuffix()  	 	    	    		  	 	  	 	  		 	 		    	 			 	   		  	 	 		 	 	   	      	  	 		 		 				 			 		  		    	 		 		  
  {
    // as install dir  	 	    	    		  	 	  	 	  		 	 		    	 			 	   		  	 	 		 	 	   	      	  	 		 		 				 			 		  		    	 		 		  
    

    
    $moduleName = "extrawatch-pro";  	 	    	    		  	 	  	 	  		 	 		    	 			 	   		  	 	 		 	 	   	      	  	 		 		 				 			 		  		    	 		 		  
    

    return $this->getWpContentDir()."/plugins/".$moduleName."/";
  }

  function renderLink($task, $otherParams)  	 	    	    		  	 	  	 	  		 	 		    	 			 	   		  	 	 		 	 	   	      	  	 		 		 				 			 		  		    	 		 		  
  {
    return $this->getRootSite() . "wp-admin/admin.php?page=extrawatch&task=" . $task . "&action=" . $otherParams;  	 	    	    		  	 	  	 	  		 	 		    	 			 	   		  	 	 		 	 	   	      	  	 		 		 				 			 		  		    	 		 		  
  }

  function getUser()  	 	    	    		  	 	  	 	  		 	 		    	 			 	   		  	 	 		 	 	   	      	  	 		 		 				 			 		  		    	 		 		  
  {
    return @$this->getUsernameById(@$this->getCurrentUserId());
  }

  function getTitle()
  {
      if (!function_exists("get_the_title")) {
          require_once dirname(__FILE__) . '/../../../../../../../../wp-load.php';
          require_once dirname(__FILE__) . '/../../../../../../../../wp-includes/class-wp-post.php';
          require_once dirname(__FILE__) . '/../../../../../../../../wp-includes/post-template.php';
      }
      $title = @get_the_title();
      return $title;
  }

    function getUsername()
    {
        return @$this->getUsernameById(@$this->getCurrentUserId());
    }

  function sendMail($recipient, $sender, $recipient2, $subject, $body, $true, $cc, $bcc, $attachment, $replyto, $replytoname)  	 	    	    		  	 	  	 	  		 	 		    	 			 	   		  	 	 		 	 	   	      	  	 		 		 				 			 		  		    	 		 		  
  {

      $fromAddress = "noreply@noemail.com";
      $charset = get_bloginfo('charset');

      $headers  = "MIME-Version: 1.0" . "\r\n";
      $headers .= "Content-type: text/html; charset=".$charset."" . "\r\n";
      $headers .= "From: ExtraWatch <".$fromAddress.">" . "\r\n";

      wp_mail( $recipient, $subject, $body, $headers);
  }

  function getDbPrefix()  	 	    	    		  	 	  	 	  		 	 		    	 			 	   		  	 	 		 	 	   	      	  	 		 		 				 			 		  		    	 		 		  
  {
    global $wpdb;
    return $wpdb->base_prefix;  	 	    	    		  	 	  	 	  		 	 		    	 			 	   		  	 	 		 	 	   	      	  	 		 		 				 			 		  		    	 		 		  
  }

  function getTimezoneOffset()  	 	    	    		  	 	  	 	  		 	 		    	 			 	   		  	 	 		 	 	   	      	  	 		 		 				 			 		  		    	 		 		  
  {
    return get_option('gmt_offset');  	 	    	    		  	 	  	 	  		 	 		    	 			 	   		  	 	 		 	 	   	      	  	 		 		 				 			 		  		    	 		 		  
  }

  function getAllowedDirsToCheckForSize()  	 	    	    		  	 	  	 	  		 	 		    	 			 	   		  	 	 		 	 	   	      	  	 		 		 				 			 		  		    	 		 		  
  {
    $dirs = array("..".DS."..".DS."..".DS."..".DS."..".DS."plugins");  	 	    	    		  	 	  	 	  		 	 		    	 			 	   		  	 	 		 	 	   	      	  	 		 		 				 			 		  		    	 		 		  
    return $dirs;
  }

  function getDirsToCheckForSize($directory)  	 	    	    		  	 	  	 	  		 	 		    	 			 	   		  	 	 		 	 	   	      	  	 		 		 				 			 		  		    	 		 		  
  {
    $dirs = array();  	 	    	    		  	 	  	 	  		 	 		    	 			 	   		  	 	 		 	 	   	      	  	 		 		 				 			 		  		    	 		 		  

    $dirs[ExtraWatchSizes::SCAN_DIR_MAIN] = "..".DS.$this->getWpContentDir().DS."plugins".DS;  	 	    	    		  	 	  	 	  		 	 		    	 			 	   		  	 	 		 	 	   	      	  	 		 		 				 			 		  		    	 		 		  
    $dirs[ExtraWatchSizes::SCAN_DIR_ADMIN] = "..".DS.$this->getWpContentDir().DS."plugins".DS;  	 	    	    		  	 	  	 	  		 	 		    	 			 	   		  	 	 		 	 	   	      	  	 		 		 				 			 		  		    	 		 		  

    $dirs[ExtraWatchSizes::REAL_DIR_MAIN] = "..".DS."..".DS."..".DS."..".DS;  	 	    	    		  	 	  	 	  		 	 		    	 			 	   		  	 	 		 	 	   	      	  	 		 		 				 			 		  		    	 		 		  
    $dirs[ExtraWatchSizes::REAL_DIR_ADMIN] = "..".DS."..".DS."..".DS."..".DS;  	 	    	    		  	 	  	 	  		 	 		    	 			 	   		  	 	 		 	 	   	      	  	 		 		 				 			 		  		    	 		 		  

    return $dirs;
  }

  function getAgentNotPublishedMsg($database) {  	 	    	    		  	 	  	 	  		 	 		    	 			 	   		  	 	 		 	 	   	      	  	 		 		 				 			 		  		    	 		 		  
    if (!is_active_widget( false, false, "extrawatchagentwidget", true )) {  	 	    	    		  	 	  	 	  		 	 		    	 			 	   		  	 	 		 	 	   	      	  	 		 		 				 			 		  		    	 		 		  
      return _EW_AGENT_NOT_PUBLISHED_ERROR_WORDPRESS;  	 	    	    		  	 	  	 	  		 	 		    	 			 	   		  	 	 		 	 	   	      	  	 		 		 				 			 		  		    	 		 		  
    }
    return FALSE;
  }


    public function getAdminEmail()  	 	    	    		  	 	  	 	  		 	 		    	 			 	   		  	 	 		 	 	   	      	  	 		 		 				 			 		  		    	 		 		  
    {
      global $current_user;  	 	    	    		  	 	  	 	  		 	 		    	 			 	   		  	 	 		 	 	   	      	  	 		 		 				 			 		  		    	 		 		  
      return $current_user->email;  	 	    	    		  	 	  	 	  		 	 		    	 			 	   		  	 	 		 	 	   	      	  	 		 		 				 			 		  		    	 		 		  
    }

    function getFormKey() {  	 	    	    		  	 	  	 	  		 	 		    	 			 	   		  	 	 		 	 	   	      	  	 		 		 				 			 		  		    	 		 		  
        return "";
    }

    public function getReviewLink()  	 	    	    		  	 	  	 	  		 	 		    	 			 	   		  	 	 		 	 	   	      	  	 		 		 				 			 		  		    	 		 		  
    {
          	 	    	    		  	 	  	 	  		 	 		    	 			 	   		  	 	 		 	 	   	      	  	 		 		 				 			 		  		    	 		 		  
        return "http://www.wordpress.org/support/view/plugin-reviews/extrawatch-pro";  	 	    	    		  	 	  	 	  		 	 		    	 			 	   		  	 	 		 	 	   	      	  	 		 		 				 			 		  		    	 		 		  
       

        
    }

    public function getVoteLink()  	 	    	    		  	 	  	 	  		 	 		    	 			 	   		  	 	 		 	 	   	      	  	 		 		 				 			 		  		    	 		 		  
    {
          	 	    	    		  	 	  	 	  		 	 		    	 			 	   		  	 	 		 	 	   	      	  	 		 		 				 			 		  		    	 		 		  
        return "http://www.wordpress.org/support/view/plugin-reviews/extrawatch-pro";  	 	    	    		  	 	  	 	  		 	 		    	 			 	   		  	 	 		 	 	   	      	  	 		 		 				 			 		  		    	 		 		  
       

        
    }

    public function getEnvironmentName()  	 	    	    		  	 	  	 	  		 	 		    	 			 	   		  	 	 		 	 	   	      	  	 		 		 				 			 		  		    	 		 		  
    {
        return self::EW_ENV_NAME;  	 	    	    		  	 	  	 	  		 	 		    	 			 	   		  	 	 		 	 	   	      	  	 		 		 				 			 		  		    	 		 		  
    }

    public function getRootPath() {  	 	    	    		  	 	  	 	  		 	 		    	 			 	   		  	 	 		 	 	   	      	  	 		 		 				 			 		  		    	 		 		  
        $path = realpath(dirname(__FILE__).DS."..".DS."..".DS."..".DS."..".DS."..".DS."..".DS."..".DS."..".DS);  	 	    	    		  	 	  	 	  		 	 		    	 			 	   		  	 	 		 	 	   	      	  	 		 		 				 			 		  		    	 		 		  
        return $path;  	 	    	    		  	 	  	 	  		 	 		    	 			 	   		  	 	 		 	 	   	      	  	 		 		 				 			 		  		    	 		 		  
    }

    public function getTempDirectory() {  	 	    	    		  	 	  	 	  		 	 		    	 			 	   		  	 	 		 	 	   	      	  	 		 		 				 			 		  		    	 		 		  
        return get_temp_dir();  	 	    	    		  	 	  	 	  		 	 		    	 			 	   		  	 	 		 	 	   	      	  	 		 		 				 			 		  		    	 		 		  
    }

    function getUserId()  	 	    	    		  	 	  	 	  		 	 		    	 			 	   		  	 	 		 	 	   	      	  	 		 		 				 			 		  		    	 		 		  
    {
        return @$this->getCurrentUserId();
    }

    public function getUsernameById($userId) {
        if (@function_exists("get_userdata") && @$userId) {
        $userInfo = @get_userdata($userId);
        if (@$userInfo) {
            return $userInfo->user_login;
        }
        }
    }

    public function getUserRealNameById($userId) {
        if (@function_exists("get_userdata") && $userId) {
        $userInfo = @get_userdata($userId);
        if (@$userInfo) {
            return $userInfo->first_name." ".$userInfo->last_name;
        }
        }
    }


    public function getExtraWatchControllerUrl() {
            return "components/com_extrawatch/extrawatch.php?";
    }

    public function renderBackendAjaxLink($extraWatchConfig, $task, $action) {
        $urlPart = array();
        $urlPart[] = $extraWatchConfig->getBackendRequestOriginUrlParam();
        $urlPart[] = $extraWatchConfig->getTokenUrlParam($extraWatchConfig->getBackendToken());
        $urlPart[] = "task=".$task;
        $urlPart[] = "action=".$action;
        return $this->getExtraWatchControllerUrl().implode("&", $urlPart);
    }

    public function renderFrontendAjaxLink($extraWatchConfig, $task, $action, $withoutToken = FALSE) {
        $urlPart = array();
        $urlPart[] = $extraWatchConfig->getFrontendRequestOriginUrlParam();
        if (!$withoutToken) {
            $urlPart[] = $extraWatchConfig->getTokenUrlParam($extraWatchConfig->getFrontendToken());
        }
        $urlPart[] = "task=".$task;
        $urlPart[] = "action=".$action;
        return $this->getExtraWatchControllerUrl().implode("&", $urlPart);
    }



    public function addStyleSheet($cssURL)  	 	    	    		  	 	  	 	  		 	 		    	 			 	   		  	 	 		 	 	   	      	  	 		 		 				 			 		  		    	 		 		  
    {
        $cssURL = str_replace($this->getRootSite(),"/", $cssURL);   //because wp_equeue_style adds this suffix
        wp_enqueue_style(md5($cssURL), $cssURL);    //md5 is used because it requires some unique identifier as style reference
   
    }

    public function redirect($url)
    {
        @wp_redirect($url, 301); //301 - HTTP header - permanently moved
        exit;
    }

    public function getAllUsersAsIdToUsernameArray($database) {  	 	    	    		  	 	  	 	  		 	 		    	 			 	   		  	 	 		 	 	   	      	  	 		 		 				 			 		  		    	 		 		  
        $query = sprintf(" SELECT id, user_login  FROM `#__users`");  	 	    	    		  	 	  	 	  		 	 		    	 			 	   		  	 	 		 	 	   	      	  	 		 		 				 			 		  		    	 		 		  
        $users = $database->objectListQuery($query);  	 	    	    		  	 	  	 	  		 	 		    	 			 	   		  	 	 		 	 	   	      	  	 		 		 				 			 		  		    	 		 		  
        $usersArray = array();  	 	    	    		  	 	  	 	  		 	 		    	 			 	   		  	 	 		 	 	   	      	  	 		 		 				 			 		  		    	 		 		  
        if (@$users)  	 	    	    		  	 	  	 	  		 	 		    	 			 	   		  	 	 		 	 	   	      	  	 		 		 				 			 		  		    	 		 		  
        for ($i=0;$i<sizeof($users);$i++) {  	 	    	    		  	 	  	 	  		 	 		    	 			 	   		  	 	 		 	 	   	      	  	 		 		 				 			 		  		    	 		 		  
            if (@$users[$i] && @$users[$i]->user_login) {  	 	    	    		  	 	  	 	  		 	 		    	 			 	   		  	 	 		 	 	   	      	  	 		 		 				 			 		  		    	 		 		  
                $usersArray[@$users[$i]->id] = @$users[$i]->user_login;  	 	    	    		  	 	  	 	  		 	 		    	 			 	   		  	 	 		 	 	   	      	  	 		 		 				 			 		  		    	 		 		  
            }
        }
        return $usersArray;  	 	    	    		  	 	  	 	  		 	 		    	 			 	   		  	 	 		 	 	   	      	  	 		 		 				 			 		  		    	 		 		  
    }

    public function addScript($scriptUrl)
    {
        $scriptUrl = str_replace($this->getRootSite(),"/", $scriptUrl);   //because wp_register_script adds this suffix
        wp_register_script(md5($scriptUrl), $scriptUrl);    //md5 is used because it requires some unique identifier as script reference
        wp_enqueue_script(md5($scriptUrl));
    }

    public function setHttpHeader($headerValue)
    {
        @header($headerValue);
    }

    public function isPHPCachingEnabled() {
        return FALSE;
    }

    public function getCMSFileSystemRootPath() {
        return ABSPATH;
    }

	public function getCMSBaseURL() {
		return get_site_url();
	}



    private function getCurrentUserId() {
        if (@function_exists("get_current_user_id")) {
            return get_current_user_id();
        }
        return false;
    }

    private function getWpContentDir() {
        if (@defined("WP_CONTENT_DIR")) {
            return basename(WP_CONTENT_DIR);
        } else return "wp-content";
    }


}


